#!/bin/bash
##
# $Source: /opt/lsb-mgateway/ewd/RCS/build.sh,v $
# $Revision: 20090813.1 $
#
# Compile routines for all versions of ewd
# for all installed versions of GT.M
#
# License: AGPL 3 ldlandis@gmail.com
#

echo "Compile ewd"

force='?'
while [ "${force}" != 'n' -a "${force}" != 'N' -a \
        "${force}" != 'y' -a "${force}" != 'Y'    \
      ]
do
  echo -n "  force recompile (y/[n])? "
  read force
done

for ewdver in */routines */m_apache
do
  for gtmver in `ls /opt/lsb-gtm/*/gtmprofile | sed 's:/gtmprofile::'`
  do
    objver=`basename ${gtmver}`
    target=${ewdver}/${objver}
    if [ -d ${target} ] ; then
      if [ ${force} == 'y' ] ; then
        rm -rf ${target}
      else
        echo "- keeping existing ${target}"
        continue
      fi
    fi
    mkdir ${target}
    (cd ${target}
     if [ -r ${gtmver}/gtmprofile_preV54000 ] ; then
       source ${gtmver}/gtmprofile_preV54000
     else
       source ${gtmver}/gtmprofile
     fi
     echo "- compiling `dirname ${ewdver}` for GT.M ${objver}" |\
       tee -a compile.log
     for r in ../*.m
     do
       echo ${r}  >> compile.log
       mumps ${r} >> compile.log 2>&1
     done
    )
  done
done


# End of $Id: build.sh,v 20090813.1 2009/08/13 08:15:47 root Exp root $
